Subject: Re: [bug#38228] Fwd: [PATCH] gnu: boost: Build with python3
From: Marius Bakke <[email-masked]>
To: [email-masked]
Cc: [email-masked]
Date: Wed, 08 Jan 2020 22:11:17 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

[email-masked] writes:

> Hello Marius,
> I apologize for taking so long: the end of the semester is near and my 
> time is a little limited.

No worries.  :-)

> I'm attaching the two patches. As you said the one that parameterizes 
> the python version of boost-with-python3 must be applied to master, the 
> other one to core-updates.

Excellent!  I went ahead and adjusted it to work with the Boost
cross-compilation changes on 'core-updates', as well as simplified it a
little:

https://git.savannah.gnu.org/cgit/guix.git/commit/?h=core-updates&id=2ac164a8107dbb07ba1ed29986859d3e936f795a

>>> The patch builds boost with python3 and parameterizes the python
>>> version, as Efraim suggested. I built it successfully on core updates.
>>> When I tried building Epour on core-updates and saw that Guix was
>>> starting to build Bash 5.0 I renounced (:D) and I built it on master
>>> with boost-with-python3 .
>> 
>> In general, working on the 'core-updates' branch requires a fairly
>> powerful computer (and lots of time), sorry about that!
>> 
>>> Libtorrent-rasterbar seems to build fine on master but some tests fail
>>> to pass and they all seem to be network related but then again this is
>>> torrent we are talking about. I didn't investigate further but I 
>>> attach
>>> the log.
>> 
>> Strange.  I suppose these tests are not run when using Boost + Python 
>> 2?
>> In any case we don't have to worry about that just yet ;-)
>
> I gave another look at Libtorrent-rasterbar and I noticed that it 
> depends directly on python2, so the answer to the failing tests could be 
> that upgrading both boost and the python version ( as was done in 
> Efraim's code that I used last time to test boost-with-python3 )  broke 
> something that a closer look to the failing tests could figure out.
>
> Right now I tested the upgraded version without problems by building the 
> following ( randomly selected) packages: innoextract, swig, libarea, 
> pbbam, cgal, openimageio. If you have a better idea of what must be 
> tested please tell me and I'll do some more tests.

Thanks for testing!  I had to adjust 'Vigra' to work with Python 3, but
it was straightforward:

https://git.savannah.gnu.org/cgit/guix.git/commit/?h=core-updates&id=a82e6faa8b993d1f3b47a8bd22c4509f7cae7ec1

>>> From 91a25fb143ad0e2e20e8ddadea0c0610849adf92 Mon Sep 17 00:00:00 2001
>>> From: Giacomo Leidi <[email-masked]>
>>> Date: Tue, 12 Nov 2019 00:24:49 +0100
>>> Subject: [PATCH] gnu: boost: Build with python3.
>>> 
>>> * gnu/packages/boost.scm (boost):
>>> [arguments]: Parameterize python version.
>>> [native-inputs]: Use python3.
>> 
>> [...]
>> 
>>>      (arguments
>>> -     `(#:tests? #f
>>> +     `(#:modules ((guix build gnu-build-system)
>>> +                  (guix build utils)
>>> +                  (srfi srfi-1))
>> 
>> If you add (guix build python-build-system) in there ...
>
> [...]
>
>>>           (replace 'configure
>>>             (lambda* (#:key inputs outputs #:allow-other-keys)
>>>               (let ((icu (assoc-ref inputs "icu4c"))
>>> +                   (python (assoc-ref inputs "python"))
>>> +                   (python-version
>>> +                    (take (string-split ,(package-version python) 
>>> #\.) 2))
>> 
>> ... then you can use (python-version (python-version python)) here and
>> below.
>
> I did add python-build-system to #:modules, but Guix kept complaining 
> that python-build-system was not importable until I added
>
> #:imported-modules ((guix build python-build-system)
>                             ,@%gnu-build-system-modules)
>
> Do you happen to have any idea of the differences from 
> #:imported-modules and #:modules? And why was using only 
> gnu-build-system possible also without adding it to #:imported-modules?

Caleb explains it very well here:

https://lists.gnu.org/archive/html/guix-devel/2019-12/msg00105.html

> Or even better: is there any kind of documentation of the arguments and 
> keywords and return values of Guix's functions? Something like this 
> https://flask.palletsprojects.com/en/1.1.x/api/ .

Unfortunately no, but documenting parts of the Guix API is being
discussed.  The procedures are typically documented in the source code
though, so 'git grep' is the best tool for now.  :-/